"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useMedama = void 0;
const react_1 = require("react");
const ProvideMedama_1 = require("./ProvideMedama");
const useMedama = (options = {}) => {
    const contextValue = (0, react_1.useContext)(ProvideMedama_1.pupilProviderContext);
    const pupilBeenProvided = 'pupil' in options ? options.pupil : undefined;
    const pupil = (0, react_1.useMemo)(() => {
        var _a, _b;
        if (pupilBeenProvided)
            return pupilBeenProvided;
        const { pupil: pupilFromContext } = (_b = (!('id' in options) || options.id == null || options.id === contextValue.id
            ? contextValue
            : (_a = contextValue.lookUp) === null || _a === void 0 ? void 0 : _a.call(contextValue, options.id))) !== null && _b !== void 0 ? _b : {};
        return pupilFromContext;
    }, ['id' in options && options, pupilBeenProvided, contextValue.pupil, contextValue.id]);
    if (pupil == null)
        throw new Error('Medama Error: ProvideMedama component must be initialized up in component tree');
    return pupil;
};
exports.useMedama = useMedama;
//# sourceMappingURL=useMedama.js.map